package mantesting;

import java.io.*;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import solver.J2B;
import solver.JNB;
import ttp.TTP1Instance;
import ttp.TTPSolution;
import utils.Deb;
import solver.*;

public class CLI {

  public static void main(String[] args) {

    if (args.length < 2) {
    //args = new String[]{"berlin52_n51_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"kroA100_n99_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"ch130_n129_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"kroA100_n495_uncorr-similar-weights_05.ttp", "cs2sa"};
    //args = new String[]{"u724_n723_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"dsj1000_n999_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"u159_n790_uncorr-similar-weights_10.ttp", "cs2sa"};
    //args = new String[]{"kroA100_n990_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"rl1304_n1303_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"fl1577_n1576_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"u159_n1580_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"d2103_n2102_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"u574_n2865_uncorr-similar-weights_05.ttp", "cs2sa"};
    //args = new String[]{"pcb3038_n3037_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"rl1304_n13030_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"usa13509_n13508_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"brd14051_n14050_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"d15112_n15111_bounded-strongly-corr_01.ttp", "cs2sa"};
    //args = new String[]{"pcb3038_n15185_uncorr-similar-weights_05.ttp", "cs2sa"};
    //args = new String[]{"fl1577_n1576_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"rl11849_n59240_uncorr-similar-weights_05.ttp", "cs2sa"};
    //args = new String[]{"usa13509_n67540_uncorr-similar-weights_05.ttp", "cs2sa"};
    //args = new String[]{"brd14051_n70250_uncorr-similar-weights_05.ttp", "cs2sa"};
    //args = new String[]{"pla7397_n73960_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"d15112_n75555_uncorr-similar-weights_05.ttp", "cs2sa"};
    //args = new String[]{"usa13509_n135080_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"brd14051_n140500_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"d15112_n151110_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"pla33810_n169045_uncorr-similar-weights_05.ttp", "cs2sa"};
    //args = new String[]{"pla33810_n338090_uncorr_10.ttp", "cs2sa"};
    //args = new String[]{"fnl4461_n4460_uncorr-similar-weights_01.ttp", "cs2sa"};
      //args = new String[]{"fnl4461_n4460_bounded-strongly-corr_06.ttp", "cs2sa"};
      //args = new String[]{"fnl4461_n13380_uncorr_10.ttp", "cs2sa"};
      //args = new String[]{"fnl4461_n44600_uncorr-similar-weights_10.ttp", "cs2sa"};
      //args = new String[]{"ch150_n1490_uncorr-similar-weights_10.ttp", "cs2sa"};
      //args = new String[]{"ch150_n1490_bounded-strongly-corr_10.ttp", "cs2sa"};     
      //args = new String[]{"ch150_n1490_uncorr_10.ttp", "cs2sa"}; all negative results    
      // args = new String[]{"ch150_n149_bounded-strongly-corr_10.ttp", "cs2sa"};
      //args = new String[]{"eil76_n75_uncorr-similar-weights_10.ttp", "cs2sa"};
      //args = new String[]{"eil76_n750_uncorr_01.ttp", "cs2sa"};
      //args = new String[]{"eil51_n50_bounded-strongly-corr_01.ttp", "cs2sa"};
      // args = new String[]{"gil262_n261_bounded-strongly-corr_01.ttp", "cs2sa"};
      //args = new String[]{"gil262_n2610_bounded-strongly-corr_01.ttp", "cs2sa"};
      //args = new String[]{"gil262_n2610_uncorr_01.ttp", "cs2sa"};
      //args = new String[]{"gil262_n2610_uncorr-similar-weights_01.ttp", "cs2sa"};
      //args = new String[]{"lin318_n317_bounded-strongly-corr_10.ttp", "cs2sa"};
      //args = new String[]{"lin318_n3170_bounded-strongly-corr_01.ttp", "cs2sa"};
      //args = new String[]{"lin318_n3170_uncorr_01.ttp", "cs2sa"};
      //args = new String[]{"lin318_n3170_uncorr-similar-weights_01.ttp", "cs2sa"};
      //args = new String[]{"d18512_n18511_bounded-strongly-corr_01.ttp", "cs2sa"};
    }
   System.out.print(args);
    String[] spl = args[0].split("_",2);

    // TTP instance name
    final String inst = args[0];
 
    // algorithm name
    final String algoName = args[1];

    // output file
    final String outputFile;
    if (args.length >= 3)
      outputFile = "./output/"+args[2];
    else
      outputFile = "./output/"+algoName+".csv";

    // runtime limit
    long runtimeLimit = 600;
    if (args.length >= 4)
      runtimeLimit = Long.parseLong(args[3]);

    // TTP instance
    final TTP1Instance ttp = new TTP1Instance(spl[0]+"-ttp/"+inst);
    int nbItems = ttp.getNbItems();

    /* algorithm to run */
    final SearchHeuristic algo;
    switch (algoName) {

      case "cs2b":
        algo = new CS2B(ttp);
      break;

      case "cs2sa":
        algo = new CS2SA(ttp);

        // tuned using irace package
//        ((CS2SA)algo).trialFactor = CS2SA.generateTFLinFit(nbItems);
//        ((CS2SA)algo).alpha = .9484;
//        ((CS2SA)algo).T0 = 3587;
//        Deb.echo(((CS2SA)algo).trialFactor + " // ");
      break;

      case "cs2sar":
        algo = new CS2SAR(ttp);
      break;


      case "ma2b":
        algo = new MA2B(ttp);
      break;

      case "j2b":
        algo = new J2B(ttp);
      break;

      case "jnb":
        algo = new JNB(ttp);
      break;

      default:
        algo = new CS2SA(ttp);
      break;
    }


    // runnable class
    class TTPRunnable implements Runnable {

      String resultLine;
      TTPSolution sx;

      @Override
      public void run() {


        /* start search & measure runtime */
        long startTime, stopTime;
        long exTime;
        startTime = System.currentTimeMillis();

        sx = algo.search();

        stopTime = System.currentTimeMillis();
        exTime = stopTime - startTime;

        /* print result */
        resultLine = inst + " " + Math.round(sx.ob) + " " + (exTime/1000.0);

      }
    };

    // my TTP runnable
    TTPRunnable ttprun = new TTPRunnable();
    ExecutorService executor = Executors.newFixedThreadPool(4);
    Future<?> future = executor.submit(ttprun);
    executor.shutdown();  // reject all further submissions

    // limit execution time to 600 seconds
    try {
    	
      future.get(runtimeLimit, TimeUnit.SECONDS);  // wait X seconds to finish
    } catch (InterruptedException e) {
      System.out.println("job was interrupted");
    } 
    catch (ExecutionException e) {
      System.out.println("caught exception: " + e.getCause());
    } 
    catch (TimeoutException e) {
      future.cancel(true);
      System.out.println("/!\\ Timeout");
    }

    // wait for execution to be done
    try {
      executor.awaitTermination(Long.MAX_VALUE, TimeUnit.NANOSECONDS);
    } catch (InterruptedException e) {
      e.printStackTrace();
    }
    // print results

    Deb.echo(ttprun.resultLine);

    // log results into text file
    try {
      File file = new File(outputFile);
      if (!file.exists()) file.createNewFile();
      Files.write(Paths.get(outputFile), (ttprun.resultLine+"\n").getBytes(), StandardOpenOption.APPEND);
    } catch (IOException e) {
      e.printStackTrace();
    }

    // save solution in a file

    try {
      String currentTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());    
      String filepath="./output/solutions/"+inst+"-"+algoName+"-"+currentTime+".txt";
      System.out.print("test>>>>>>>>>>>>>>>>"+filepath);
      PrintWriter pw = new PrintWriter("./output/solutions/result.txt");
     
      System.out.println(ttprun.sx);
      pw.println(ttprun.sx);
      pw.close();
      
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    }
    
  }
}
